#ifndef __RELATION_H
#include <relation.h>
#endif


////////////////////////////////////////////////

class TEffObb:public TRelation
{
  // @DPRIV
  TArray _obbligati;
  int _oldobbligati;
  // @END
protected:
  // @FPROT
  int write_rec(bool re, const TRectype& r, TLocalisamfile& f);
  int cancella(TLocalisamfile& f, int da, int a);
  int registra(bool re, bool force);
  int read_obbligati();
  // @END
public:
  virtual int next(TReclock lockop=_nolock) {return (lfile().next(lockop) || read_obbligati());}
  virtual int prev(TReclock lockop=_nolock) {return (lfile().prev(lockop) || read_obbligati());}
  virtual int first(TReclock lockop=_nolock) {return (lfile().first(lockop) || read_obbligati());}
  virtual int last(TReclock lockop=_nolock) {return (lfile().last(lockop) || read_obbligati());}
  virtual int skip(TReclock lockop=_nolock) {return (lfile().skip(lockop) || read_obbligati());}
  virtual int read(TIsamop = _isgteq, TReclock lockop = _nolock, TDate& atdate = (TDate&) botime);
  virtual int write(bool force=TRUE, TDate& atdate = (TDate&) botime);
  virtual int rewrite(bool force=TRUE, TDate& atdate = (TDate&) botime);
  virtual int remove(TDate& atdate = (TDate&) botime);

  TRectype& obbligato(int i);
  int obbligati_items() const {return _obbligati.items();}
  void destroy_rows();

  TEffObb();
  virtual ~TEffObb() {}
};
